#ifndef SD_DRIVER_H_
#define SD_DRIVER_H_

#include "xbasic_types.h"


//#define SD_GPIO_Data (XPAR_SD_GPIO_BASEADDR)          // read or write input/output
#define SD_GPIO_Data (XPAR_XPS_GPIO_0_BASEADDR)          // read or write input/output
//#define SD_GPIO_TRI  (XPAR_SD_GPIO_BASEADDR + 0x04)   // dynamically configure I or O
#define SD_GPIO_TRI  (XPAR_XPS_GPIO_0_BASEADDR + 0x04)   // dynamically configure I or O


  // Set Data Directions
  
      void SD_DAT3_IN(void);
      void SD_DAT3_OUT(void);
      void SD_DAT0_IN(void);
      void SD_DAT0_OUT(void);
      void SD_CMD_IN(void);
      void SD_CMD_OUT(void);
      void SD_CLK_OUT(void);
  
  //  SD Card Outputs level

      void SD_DAT3_SET(void);  
      void SD_DAT3_RESET(void);
      void SD_DAT0_SET(void);
      void SD_DAT0_RESET(void);
      void SD_CMD_SET(void);
      void SD_CMD_RESET(void);
      void SD_CLK_SET(void);
      void SD_CLK_RESET(void);

  //  SD Card Inputs Read
  
      unsigned int SD_DAT3_Read(void);  
      unsigned int SD_DAT0_Read(void);
      unsigned int SD_CMD_Read(void); 

      Xboolean SD_Init(void);
      Xboolean SD_read_block(Xuint32 block_number, Xuint8 *buff); // richard add, return 0: success
      Xboolean SD_GetCSD(Xuint8 szCSD[], Xuint8 len);
      Xboolean SD_GetCID(Xuint8 szCID[], Xuint8 len);
      
      void Ncr(void);
      void Ncc(void);
      Xuint8 send_cmd(Xuint8 *in);
      Xuint8 send_cmd(Xuint8 *);
      Xuint8 response_R(Xuint8 s);

#endif  
