/*
 *
 *		Projekt i EDA385
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"
#include "stdio.h"
#include "xutil.h"
#include "xuartlite_l.h"
#include "xgpio_l.h"
#include "xgpio.h"
#include "xio.h"
//#include "xintc.h"
//#include "vga_ctrl_int.h"

#include "list.h"
#include "io.h"
#include "fat12.h"



Xboolean image_loaded = XFALSE;


//----------------------------------------------------
// INTERRUPT HANDLER FUNCTION
//----------------------------------------------------
//void VGA_CTRL_INT_Intr_Handler(void * baseaddr_p)
//{	
//	static unsigned int row_counter = 0;
//	static unsigned int frame_counter = 0;
//	
//	Xuint32 baseaddr;
//	int i;
//	
//	
//	
//	baseaddr = (Xuint32) baseaddr_p;
//	
//	if (image_loaded == XTRUE) {
//		if (row_counter % 2 == frame_counter) {
//			for(i = 0; i < 160; i++) {
//				XIo_Out32(XPAR_VGA_CTRL_INT_0_MEM0_BASEADDR+4*i, XIo_In32(XPAR_MICRON_RAM_MEM0_BASEADDR+(479-row_counter)*640+i*4+3*4));
//			} 
//		}
//	}
//	
//	row_counter++;
//	if (row_counter >= 480) {
//		row_counter = 0;
//		frame_counter++;
//		if (frame_counter >= 2) {
//			frame_counter = 0;
//		}
//	}	
//}


int main (void) {
	// ---------------------------------------------------------------------
	//										INTERRUPT STUFF
	// ---------------------------------------------------------------------
  
//	xil_printf("Init interrupt stuff\r\n");
//  
//	
//	// register interrupt handler
//	xil_printf("  - Registering interrupt handler\r\n");
//	XIntc_RegisterHandler(XPAR_XPS_INTC_0_BASEADDR,
//			XPAR_XPS_INTC_0_VGA_CTRL_INT_0_IP2INTC_IRPT_INTR,
//			VGA_CTRL_INT_Intr_Handler,
//   (void *)XPAR_VGA_CTRL_INT_0_BASEADDR);
//	
//	// Enable INTC interrupts
//	XIntc_mMasterEnable(XPAR_XPS_INTC_0_BASEADDR);
//	XIntc_mEnableIntr(XPAR_XPS_INTC_0_BASEADDR, XPAR_VGA_CTRL_INT_0_IP2INTC_IRPT_MASK);
//		
//	// Enable VGA interrupts
//	VGA_CTRL_INT_EnableInterrupt((Xuint32*)XPAR_VGA_CTRL_INT_0_BASEADDR);
//	
//	// Enable Microblaze interrupts
//	microblaze_enable_interrupts();

	// ---------------------------------------------------------------------
	//										FAT12 STUFF
	// ---------------------------------------------------------------------


   /*
    * Enable and initialize cache
    */
   #if XPAR_MICROBLAZE_0_USE_ICACHE
      microblaze_init_icache_range(0, XPAR_MICROBLAZE_0_CACHE_BYTE_SIZE);
      microblaze_enable_icache();
   #endif

   #if XPAR_MICROBLAZE_0_USE_DCACHE
      microblaze_init_dcache_range(0, XPAR_MICROBLAZE_0_DCACHE_BYTE_SIZE);
      microblaze_enable_dcache();
   #endif
	/*
    */

	
	DIR_t					dir;
	unsigned int		dir_address;
	unsigned int		i;
	unsigned char		file_buffer[512];
	unsigned int		magic_number;
	unsigned int		width;
	unsigned int		height;
	
	
   Xuint8 Value_1;
   Xuint8 Value_2 ;
   Xuint8 Value_3;
   Xuint8 Value_4 ;

	// paint whole screen black
//	for(i = 0; i < 160; i++) {
//		XIo_Out32(XPAR_VGA_CTRL_INT_0_MEM0_BASEADDR+4*i, 0x00000000);
//	}
	
	
	// init io, the sd card
	init_io();
	
	// get some values from mbr and vbr
	init_vbr();
	
	// print the values we got
	print_vbr();
	
	
	// get the address for the root directory
	dir_address = fat32.root_dir_sector*fat32.bytes_per_sector;
	// load the first directory entry data into dir
	load_dir(&dir, dir_address);
	// print the first directory entry
	print_dir(&dir);
	
	
	
	
	list_t* list = list_new();
	create_file_list(&dir, list);
	list_t* it = list->next;
	
	
	
	
	Value_1 = XIo_In8(XPAR_MICRON_RAM_MEM0_BASEADDR+9);
	Value_2 = XIo_In8(XPAR_MICRON_RAM_MEM0_BASEADDR+10);
	Value_3 = XIo_In8(XPAR_MICRON_RAM_MEM0_BASEADDR+11);
	Value_4 = XIo_In8(XPAR_MICRON_RAM_MEM0_BASEADDR+12);
	
	xil_printf(" Value_1 = %x\r\n",Value_1);
	xil_printf(" Value_2 = %x\r\n",Value_2);
	xil_printf(" Value_3 = %x\r\n",Value_3);
	xil_printf(" Value_4 = %x\r\n",Value_4);

	
	  xil_printf(" Debugging hook : it = %d", it->size);
	
	while (it != NULL) {
		//xil_printf("%s.%s \t clust no: %d\t size: %d\r\n", it->filename, it->ext, it->cluster_no, it->size);
		// each .ded file is 307212
		if (it->size == 307212) {
			// L as in LENNA.DED, R as in REDS.DED
			
			xil_printf(" Debugging hook : %s", it->filename[0]);
			
			if (it->filename[0] == 'i') {
				xil_printf("Copying file to ram: %s\r\n", it->filename);
				copy_file(XPAR_MICRON_RAM_MEM0_BASEADDR, it->cluster_no, 307212);
			}
		}
		it = it->next;
	}
		
	
	magic_number = XIo_In32(XPAR_MICRON_RAM_MEM0_BASEADDR);
	width = XIo_In32(XPAR_MICRON_RAM_MEM0_BASEADDR+4);
	height = XIo_In32(XPAR_MICRON_RAM_MEM0_BASEADDR+8);
	
	xil_printf("Magic number: 0x%08x\r\n", magic_number);
	xil_printf("Width: %d\r\n", width);
	xil_printf("Height: %d\r\n", height);
	
	image_loaded = XTRUE;
	
	// it's actually here we want to enable the interrupts, then the loading of the images
	// goes much faster



	
	while (1) 
	{
		// do nothing
	}
	
	free(&list);
	
	
	
	/*
    * Disable cache
    */
   #if XPAR_MICROBLAZE_0_USE_DCACHE
      microblaze_disable_dcache();
      microblaze_init_dcache_range(0, XPAR_MICROBLAZE_0_DCACHE_BYTE_SIZE);
   #endif

   #if XPAR_MICROBLAZE_0_USE_ICACHE
      microblaze_disable_icache();
      microblaze_init_icache_range(0, XPAR_MICROBLAZE_0_CACHE_BYTE_SIZE);
   #endif
	/*
    */

   print("-- Exiting main() --\r\n");
   return 0;
}






