/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdio.h"
#include "stdlib.h"
#include "list.h"
#include "io.h" // for my_memcpy

list_t* list_new()
{
	list_t* 	head;
	head = malloc(sizeof(list_t));
	if (head == NULL) {
		xil_printf("Failed to alloc memory\n");
	}

	head->next = NULL;
	head->cluster_no = 0;
	head->size = 0;

}

void list_add(list_t* list, unsigned int cluster_no, unsigned int size, const char* filename, const char* ext)
{
	list_t*		element;
	element = malloc(sizeof(list_t));
	if (element == NULL) {
		xil_printf("Failed to alloc memory\n");
	}

	element->cluster_no = cluster_no;
	element->size = size;
	
	my_memcpy(element->filename, filename, 8);
	my_memcpy(element->ext, ext, 8);
	
	element->next = list->next;
	list->next = element;
}

void list_free(list_t** head)
{
	list_t*		it;
	list_t*		tmp;

	it = *head;

	while (it != NULL) {	
		tmp = it->next;
		free(it);	
		it = tmp;
	}
}
